package mastermind.engine;

import mastermind.model.Guess;
import mastermind.model.Result;

/**
 * Mastermind Engine Interface: Enthält die Logik für das Spiel.
 */
/* -----------------------------------------------------------------------------
 * Version History:
 * 2012-05-04.v01   FeRo    init version
 * -----------------------------------------------------------------------------
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 * @version 2012-05-04.v01
 */
public interface IMastermindEngine
{

    /**
     * Setzt das zu erratende Muster (Guess)
     * @param hiddenPattern the hiddenPattern to set
     * @param showCode true: shows hidden code
     */
    void setHiddenPattern(Guess hiddenPattern, boolean showCode);

    /**
     * Gibt zurück ob gewonnen oder nicht. Vergleicht Guess == hiddenPattern
     * @param guess Kombination die geraten wurde
     * @return ob gewonnen oder nicht
     */
    boolean hasWon(Guess guess);

    /**
     * Berechnet die Anzahl Stifte mit richtiger Farbe und richtiger Position (schwarz) sowie nur richtigen Farbe (weiss) sowie ob Gewonnen oder nicht.
     * @param guess Kombination die geraten wurde
     * @return Result mit den Anzahl Schwarzen / Weissen stifte
     */
    Result getResult(Guess guess);
}
