package mastermind.logic;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInput;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;

/**
 * Mastermind Serializer: Serialize / DeSerialize Object
 */
/* -----------------------------------------------------------------------------
 * Version History:
 * 2012-05-18.v01   FeRo    init version
 * 2012-05-19.v01   FeRo    clean up
 * -----------------------------------------------------------------------------
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 * @version 2012-05-19.v01
 */
public abstract class Serializer
{

    private static ObjectOutput output;
    private static FileOutputStream fileOuputStream;
    private static FileInputStream fileInputStream;

    /**
     * Serializiert ein Objekt und speichert es
     * @param file Datei in welcher das Objekt gespeichert werden soll
     * @param obj Das zu speichernde Objekt
     */
    public static void Serialize(File file, Object obj)
    {
        try {
            fileOuputStream = new FileOutputStream(file, false);
            output = new ObjectOutputStream(fileOuputStream);
            output.writeObject(obj);
            output.close();
            fileOuputStream.close();
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }
    }

    /**
     * Lädt ein Objekt aus einer Datei (deSerialize)
     * @param file Dateiname wo das Objekt gespeichert ist
     * @return Objekt welches geladen wurde
     */
    public static Object DeSerialize(File file)
    {
        Object obj = null;
        try {
            fileInputStream = new FileInputStream(file);
            ObjectInput input;
            input = new ObjectInputStream(fileInputStream);
            obj = input.readObject();
            fileInputStream.close();
            input.close();
        } catch (Exception ex) {
            System.out.println(ex.getMessage());
        }
        return obj;
    }
}
