package mastermind.solver;

import java.util.ArrayList;
import mastermind.logic.RandomGuess;
import mastermind.model.Guess;
import mastermind.model.Result;

/**
 * Mastermind Solver: Bruteforce.
 */
/* -----------------------------------------------------------------------------
 * Version History:
 * 2012-05-03.v01   FeRo    init version
 * -----------------------------------------------------------------------------
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 * @version 2012-05-03.v02
 */
public class SolverBruteforce implements ISolver
{
    // Zufalls Guess

    private ArrayList<Guess> historyGuess;

    /**
     * Konstruktor
     */
    public SolverBruteforce()
    {
        historyGuess = new ArrayList<Guess>();
    }

    /**
     * Berechnet den nächsten Guess
     * @param lastResult des vorherigen Guess
     * @param guessID der wie vielte Rateversuch
     * @return nächsten Guess
     */
    @Override
    public Guess getNextGuess(Result lastResult, int guessID)
    {
        Guess myGuess;

        // bruteforce
        do {
            myGuess = RandomGuess.genRandomGuess();
            if (historyGuess.contains(myGuess)) {
                myGuess = null;
            }
        } while (myGuess == null);
        historyGuess.add(myGuess);
        return myGuess;
    }
}
