
package mastermind.logic;

import java.util.logging.Level;
import java.util.logging.Logger;
import mastermind.model.Settings;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author Felix Rohrer <felix.rohrer@stud.hslu.ch>
 */
public class SettingsHandlerTest {

    public SettingsHandlerTest() {
    }

    /**
     * Test of getInstance method, of class SettingsHandler.
     */
    @Test
    public void testGetInstance()
    {
        System.out.println("getInstance");
        SettingsHandler result = SettingsHandler.getInstance();
        // must be an object - not null
        assertNotNull(result);
        // must be a Settings.Class Object
        assertEquals(new SettingsHandler().getClass(), result.getClass());
    }

    /**
     * Test of getSettings method, of class SettingsHandler.
     */
    @Test
    public void testGetSettings()
    {
        System.out.println("getSettings");
        SettingsHandler instance = new SettingsHandler();
        Settings expResult = null;
        Settings result = instance.getSettings();
        assertEquals(new Settings().getClass(), result.getClass());
    }

    /**
     * Test of validSettings method, of class SettingsHandler.
     */
    @Test
    public void testValidSettings()
    {
        System.out.println("validSettings: true");
        SettingsHandler instance = new SettingsHandler();
        // define settings
        int numberOfColors = 4;
        boolean allowDuplicateColor = false;
        int numberOfPegs = 4;
        int numberOfRows = 4;
        try {
            instance.getSettings().setSettings(numberOfColors, allowDuplicateColor, numberOfPegs, numberOfRows);
        } catch (Exception ex) {
            Logger.getLogger(SettingsHandlerTest.class.getName()).log(Level.SEVERE, null, ex);
        }

        boolean expResult = true;
        boolean result = instance.validSettings();
        assertEquals(expResult, result);

        // invalid settings
        System.out.println("validSettings: false");
        try {
            instance.getSettings().setAllowDuplicateColor(false);
            instance.getSettings().setNumberOfColors(4);
            instance.getSettings().setNumberOfPegs(6);
        } catch (Exception ex) {
            Logger.getLogger(SettingsHandlerTest.class.getName()).log(Level.SEVERE, null, ex);
        }
        expResult = false;
        result = instance.validSettings();
        assertEquals(expResult, result);

    }

}